;;; Liste des Xrefs dans un dessin
;;; Dominique VAQUAND 27.04.2016

;;; (ListeDesXref "CheminEtNomdufichier")
;;; (ListeDesXref nil) si non criture dans un fichier

(defun ExtractionListeDesXref (NomDuFichier / Obj	Index Flag ObjXref VlaObj Nom
		     Chemin Fic)

  (Vl-load-com)

  (setq	Obj
	 (ssget
	   "x"
	   (list
	     (cons 0 "DGNUNDERLAY,DWFUNDERLAY,PDFUNDERLAY,IMAGE,INSERT")
	   )
	 )
  )

  (setq	index 0
	Info ""
  )

  (if obj

    (repeat (sslength obj)

      (setq Flag nil)

      (setq ObjXref (ssname obj index))

      (setq VlaObj (vlax-ename->vla-object ObjXref))

      (cond

	;; c'est un bloc
	((and (= (cdr (assoc 0 (entget ObjXref))) "INSERT")
	      (vlax-property-available-p VlaObj 'path)
	 )
	 (setq Nom    (vla-get-name vlaobj)
	       Chemin (vla-get-path vlaobj)
	       Flag   T
	 )
	 ;; c'est un DGN
	)
	((= (cdr (assoc 0 (entget ObjXref))) "DGNUNDERLAY")
	 (setq Nom    (vla-get-underlayname vlaobj)
	       Chemin (vla-get-file vlaobj)
	       Flag   T
	 )
	)
	;; c'est un DWF
	((= (cdr (assoc 0 (entget ObjXref))) "DWFUNDERLAY")
	 (setq Nom    (vla-get-underlayname vlaobj)
	       Chemin (vla-get-file vlaobj)
	       Flag   T
	 )
	)
	;; c'est un PDF
	((= (cdr (assoc 0 (entget ObjXref))) "PDFUNDERLAY")
	 (setq Nom    (vla-get-underlayname vlaobj)
	       Chemin (vla-get-file vlaobj)
	       Flag   T
	 )
	)
	;; c'est une image
	((= (cdr (assoc 0 (entget ObjXref))) "IMAGE")
	 (setq Nom    (vla-get-name vlaobj)
	       Chemin (vla-get-imagefile vlaobj)
	       Flag   T
	 )
	)

      )

      (if (= Flag T)

	  (setq
	    Info (strcat
		   info
		   (getvar "dwgprefix")
		   (getvar "dwgname")
		   ","
		   Nom
		   ","
		   Chemin
		   ","
		   (strcase (substr (VL-FILENAME-EXTENSION chemin) 2))
		   "\n"
		 )
	  )


      )
      ;; if


      (setq index (1+ index))

    )
    ;; repeat

  )
;;;; if

  (if (/= info nil)
    (progn

      (princ info)

      (if (/= NomDuFichier nil)
	(progn
	  (setq Fic (open NomDuFichier "A"))
	  (princ info fic)
	  (close fic)

	  (princ (strcat "\nListe des XREF mmorise dans: " NomDuFichier
			 "\nFichierSourceDWG,FichierXref,NomXref,ExtensionFichier"))
	)
      )
    )
  )


  (princ)

)


