;;; Dtecter objets loigns
;;; Rtablir liste des calques
;;; Les Cahiers AutoCAD N62

(defun c:DetecterObjetsEloignes ( / VS_PDMODE)

  ;; si l'tat "$ObjetsEloignes" existe on le supprime
  (if (layerstate-has "$ObjetsEloignes")
    (layerstate-delete "$ObjetsEloignes")
    )

  ;; on bascule dans l'espace objet
  (command "TILEMODE" 1)
  
  ;; on mmorise l'tat de calque actuel
  (layerstate-save  "$ObjetsEloignes"  nil nil)

  ;; On libre, active et dverouille tous les calques
  (command "_layer" "_ON" "*" "_T" "*" "_U" "*" "")
  
  ;; on active les cadres des objets NETTOYER sans qu'ils soient imprimables
  (setvar "WIPEOUTFRAME" 2)

  ;; On cr le calque $LimitesObjets
    (command "_layer" "_N" "$LimitesObjets"
	     "_ON" "$LimitesObjets"
	     "_T" "$LimitesObjets"
	     "_U" "$LimitesObjets"
	     "_plot" "_NO" "$LimitesObjets" "")

  ;; On mmorise pdmode du code des accrochages aux objets
  (setq VS_PDMODE (getvar "PDMODE"))
  
  ;; On dfinit une forme de point
  (setvar "PDMODE" 3)

  ;; On active le scu gnral
  (command "_ucs" "")
  
  ;; On cr le rectangle aux limites mini et maxi du dessin
  (command "_rectang" (getvar "extmin")(getvar "extmax"))
  (command "_chprop" (entlast) "" "_layer" "$LimitesObjets" "_CO" "_red" "")

  ;; On lance un zoom tendu
  (command "_zoom" "_e")

  ;; On remet le SCU et PDMODE comme avant
  (command "_ucs" "_p")
  (setvar "PDMODE" VS_PDMODE)

  (princ)

  )


(defun c:RetablirListeDesCalques ()

  (layerstate-restore "$ObjetsEloignes"  nil 5)

  ;;; On supprime le rectangle du calque $LimitesObjets

  (if (ssget "x" (list (cons 0 "LWPOLYLINE") (cons 8 "$LimitesObjets")))
    (command "_erase" (ssget "x" (list (cons 0 "LWPOLYLINE") (cons 8 "$LimitesObjets"))) "")
    )

  (princ)

  )

